#include <stdio.h>

typedef unsigned long int DWORD;
typedef unsigned long long QWORD;

extern "C" {
DWORD _ctl_intrnl_DS = 0;

// CPU Clock mesuring support
DWORD _ctl_intrnl_ticks = 0;
QWORD _ctl_intrnl_qt1 = 0, _ctl_intrnl_qt2 = 0;

void _ctl_TimerHandler_mes ();

}

main ()
{
  asm {  // Mesure system CPU CLOCK freq
   mov     ax, ds
   mov     word ptr _ctl_intrnl_DS, ax

   push ds
   mov     ax,cs
   mov     ds,ax

   cli
   mov     edx,offset _ctl_TimerHandler_mes
   mov     ax,2506H
   mov     cl,0x8
   int     21h
   mov al, 0x00
   out 0x40, al
   mov al, 0x00
   out 0x40, al
   pop     ds
   sti

  wait_for_done:
   cmp _ctl_intrnl_ticks, 11
   jbe wait_for_done
  }
 long long TSCperMS = (_ctl_intrnl_qt2 - _ctl_intrnl_qt1)/550 * 1000;
 printf ( "Freq=%llu Hz\n", TSCperMS );
 return 0;
}