;
; PROJECT: CTL 2000
; FILE: sheduler.asm
; DESC: Lowest possible level for supporting Sheduling for DOSX
; VERSION: CTL MultiThread 2002
; 
; [ Only mesuring procedure left ]
;
include \dm\include\mac32.asm

                 _TEXT segment dword public 'CODE'
                 assume cs:_TEXT,ds:DGROUP

; Time Counter
extrn  __ctl_intrnl_DS:            dword
extrn  __ctl_intrnl_ticks:         dword
extrn  __ctl_intrnl_qt1:           qword
extrn  __ctl_intrnl_qt2:           qword

public __ctl_TimerHandler_mes

__ctl_TimerHandler_mes proc    near
        push eax
        push edx
        db 0fh, 31h  ; rdtsc

        push ebx
        push ds

        mov ebx, cs:__ctl_intrnl_DS
        mov ds, bx
        mov ebx, __ctl_intrnl_ticks
        inc ebx
        mov __ctl_intrnl_ticks, ebx
        cmp ebx, 1
        je set_qt1
        cmp ebx, 11
        je set_qt2

 __ctl_TimerHandler_mes_ret:
        pop ds
        pop ebx
        pop edx
        cli                              ; restore intr ctrl 8259
        mov al, 20h
        out 20h, al
        sti
        pop eax
        iretd
 set_qt1:
        mov dword ptr __ctl_intrnl_qt1, eax
        mov dword ptr __ctl_intrnl_qt1+4, edx
        jmp __ctl_TimerHandler_mes_ret
 set_qt2:
        mov dword ptr __ctl_intrnl_qt2, eax
        mov dword ptr __ctl_intrnl_qt2+4, edx
        jmp __ctl_TimerHandler_mes_ret
__ctl_TimerHandler_mes endp

_TEXT	ends
	end